<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.5"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>DayZ: scripts/4_World/Entities/Firearms/Pistol/Flaregun.c Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../doxygen_light.png"/></td>
  <td id="projectalign">
   <div id="projectname">DayZ<span id="projectnumber">&#160;1.19.155390</span>
   </div>
   <div id="projectbrief">DayZ Script Documentation Courtecy of P4K1TZ</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.5 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "../../search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(document).ready(function(){initNavTree('d6/dd0/_flaregun_8c_source.html','../../'); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="headertitle"><div class="title">Flaregun.c</div></div>
</div><!--header-->
<div class="contents">
<a href="../../d6/dd0/_flaregun_8c.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno"><a class="line" href="../../d6/dd0/_flaregun_8c.html#a94a48508f9de4c308a774a69b91c9fd9">    1</a></span><span class="keyword">enum</span> <a class="code hl_enumeration" href="../../d6/dd0/_flaregun_8c.html#a94a48508f9de4c308a774a69b91c9fd9">FLAREAnimState</a></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span>{</div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno"><a class="line" href="../../d6/dd0/_flaregun_8c.html#a94a48508f9de4c308a774a69b91c9fd9ad2f7012ff73e5095016573ed46f929a4">    3</a></span>    <a class="code hl_enumvalue" href="../../d6/dd0/_flaregun_8c.html#a94a48508f9de4c308a774a69b91c9fd9ad2f7012ff73e5095016573ed46f929a4">COCKED</a>      = 0,    </div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno"><a class="line" href="../../d6/dd0/_flaregun_8c.html#a94a48508f9de4c308a774a69b91c9fd9a5524ea9109ec7996fc51cbb86426b8f1">    4</a></span>    <a class="code hl_enumvalue" href="../../d6/dd0/_flaregun_8c.html#a94a48508f9de4c308a774a69b91c9fd9a5524ea9109ec7996fc51cbb86426b8f1">UNCOCKED</a>    = 1,    </div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span>};</div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span> </div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno"><a class="line" href="../../d6/dd0/_flaregun_8c.html#a2f979fdd8cbc87aab4152a13b56d2163">    7</a></span><span class="keyword">enum</span> <a class="code hl_enumeration" href="../../d6/dd0/_flaregun_8c.html#a2f979fdd8cbc87aab4152a13b56d2163">FLAREStableStateID</a></div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span>{</div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span>    <a class="code hl_variable" href="../../d6/dd0/_flaregun_8c.html#a6ce26a62afab55d7606ad4e92428b30c">UNKNOWN</a>             =  0,</div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span>    <a class="code hl_variable" href="../../d6/dd0/_flaregun_8c.html#a891fbec6fb0d74aea9e064d13b59c9e0">Empty</a>               =  1,</div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span>    <a class="code hl_variable" href="../../d6/dd0/_flaregun_8c.html#a8aa2378201749f3aa5ffa8dd152c8e95">Fireout</a>             =  2,</div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span>    <a class="code hl_variable" href="../../d6/dd0/_flaregun_8c.html#a211f8e095b3b0e62b5e1fbc5ac330c15">Loaded</a>              =  3,</div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span>}</div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span> </div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span><span class="keyword">class </span>FLAREEmpty <span class="keyword">extends</span> <a class="code hl_class" href="../../dc/dcc/class_weapon_stable_state.html">WeaponStableState</a></div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span>{</div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_variable" href="../../d2/db3/_single_shot_pistol___base_8c.html#a3ed70c6f00023473563b38dd40750479">OnEntry</a> (<a class="code hl_class" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a> e) { <span class="keywordflow">if</span> (<a class="code hl_class" href="../../d9/df7/class_log_manager.html">LogManager</a>.<a class="code hl_function" href="../../d9/df7/class_log_manager.html#a1936dba0ee4da1a581859d6603178326">IsWeaponLogEnable</a>()) { <a class="code hl_function" href="../../dc/d1d/4___world_2_entities_2_firearms_2_debug_8c.html#a40adfc1e22a9b751658055847f9c4b83">wpnPrint</a>(<span class="stringliteral">&quot;[wpnfsm] &quot;</span> + <a class="code hl_class" href="../../d8/d83/class_object.html">Object</a>.GetDebugName(<a class="code hl_variable" href="../../de/dc3/_guards_8c.html#ad0af4429be0c56056dbf78f31157a010">m_weapon</a>) + <span class="stringliteral">&quot; { Empty E&quot;</span>); } super.OnEntry(e); }</div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno"><a class="line" href="../../d6/dd0/_flaregun_8c.html#aa40f8697dfa587f8adabc8640bc98ad8">   18</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../dc/dcc/class_weapon_stable_state.html#a2b24124714481d5944daedea764ef07a">OnExit</a> (<a class="code hl_class" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a> e) { super.OnExit(e); <span class="keywordflow">if</span> (<a class="code hl_class" href="../../d9/df7/class_log_manager.html">LogManager</a>.<a class="code hl_function" href="../../d9/df7/class_log_manager.html#a1936dba0ee4da1a581859d6603178326">IsWeaponLogEnable</a>()) { <a class="code hl_function" href="../../dc/d1d/4___world_2_entities_2_firearms_2_debug_8c.html#a40adfc1e22a9b751658055847f9c4b83">wpnPrint</a>(<span class="stringliteral">&quot;[wpnfsm] &quot;</span> + <a class="code hl_class" href="../../d8/d83/class_object.html">Object</a>.GetDebugName(<a class="code hl_variable" href="../../de/dc3/_guards_8c.html#ad0af4429be0c56056dbf78f31157a010">m_weapon</a>) + <span class="stringliteral">&quot; } Empty E&quot;</span>); } }</div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno"><a class="line" href="../../d6/dd0/_flaregun_8c.html#a891fbec6fb0d74aea9e064d13b59c9e0">   19</a></span>    <span class="keyword">override</span> <span class="keywordtype">int</span> <a class="code hl_function" href="../../dc/dcc/class_weapon_stable_state.html#a71d886cf9e101812137133a25a5efc5d">GetCurrentStateID</a> () { <span class="keywordflow">return</span> <a class="code hl_enumeration" href="../../d6/dd0/_flaregun_8c.html#a2f979fdd8cbc87aab4152a13b56d2163">FLAREStableStateID</a>.Empty; }</div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno"><a class="line" href="../../d6/dd0/_flaregun_8c.html#a8aa2378201749f3aa5ffa8dd152c8e95">   20</a></span>    <span class="keyword">override</span> <span class="keywordtype">bool</span> <a class="code hl_function" href="../../dc/dcc/class_weapon_stable_state.html#a4b66543cd3ec146ccb5bdf7da9b82be2">HasBullet</a> () { <span class="keywordflow">return</span> <span class="keyword">false</span>; }</div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno"><a class="line" href="../../d6/dd0/_flaregun_8c.html#af2a2200b1debc914a8e34252c33e8dfe">   21</a></span>    <span class="keyword">override</span> <span class="keywordtype">bool</span> <a class="code hl_function" href="../../dc/dcc/class_weapon_stable_state.html#ae6fd560194ec4459eb3731047b22d510">HasMagazine</a> () { <span class="keywordflow">return</span> <span class="keyword">false</span>; }</div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno"><a class="line" href="../../d6/dd0/_flaregun_8c.html#aac14d196e64cad535c5aa50f0c954df3">   22</a></span>    <span class="keyword">override</span> <span class="keywordtype">bool</span> <a class="code hl_function" href="../../dc/dcc/class_weapon_stable_state.html#a17fafa12bb56d472c515b8dc2a1669a8">IsJammed</a> () { <span class="keywordflow">return</span> <span class="keyword">false</span>; }</div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno"><a class="line" href="../../d6/dd0/_flaregun_8c.html#a4c09bde99bd60b7e18e0da605a7882ac">   23</a></span>    <span class="keyword">override</span> <span class="keywordtype">bool</span> <a class="code hl_function" href="../../dc/dcc/class_weapon_stable_state.html#a0977d8061eff3cff870b2e8bfc1c4fcf">IsBoltOpen</a> () { <span class="keywordflow">return</span> <span class="keyword">false</span>; }</div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno"><a class="line" href="../../d6/dd0/_flaregun_8c.html#a5505b40857f04731ef377a6be07e9d8c">   24</a></span>    <span class="keyword">override</span> <span class="keywordtype">bool</span> <a class="code hl_function" href="../../dc/dcc/class_weapon_stable_state.html#ac25b31cf36d1dadc8120054f1eb43e5e">IsRepairEnabled</a> () { <span class="keywordflow">return</span> <span class="keyword">true</span>; }</div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno"><a class="line" href="../../d6/dd0/_flaregun_8c.html#aecb416b07a0879e66f05969cc59bd671">   25</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../dc/dcc/class_weapon_stable_state.html#a3ec895a8ef12f28fbb3e1acb39c82369">InitMuzzleArray</a> () { <a class="code hl_variable" href="../../d8/d8f/_weapon_stable_state_8c.html#a99c0c3c305a37383f835abc512f2be3f">m_muzzleHasBullet</a> = {<a class="code hl_enumeration" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38">MuzzleState</a>.E}; }</div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span>};</div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span><span class="keyword">class </span>FLAREFireout <span class="keyword">extends</span> <a class="code hl_class" href="../../dc/dcc/class_weapon_stable_state.html">WeaponStableState</a></div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span>{</div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno"><a class="line" href="../../dc/dcc/class_weapon_stable_state.html#a4317e82e93379b1e0cdcb1112796367d">   29</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../dc/dcc/class_weapon_stable_state.html#a4317e82e93379b1e0cdcb1112796367d">OnEntry</a> (<a class="code hl_class" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a> e) { <span class="keywordflow">if</span> (<a class="code hl_class" href="../../d9/df7/class_log_manager.html">LogManager</a>.<a class="code hl_function" href="../../d9/df7/class_log_manager.html#a1936dba0ee4da1a581859d6603178326">IsWeaponLogEnable</a>()) { <a class="code hl_function" href="../../dc/d1d/4___world_2_entities_2_firearms_2_debug_8c.html#a40adfc1e22a9b751658055847f9c4b83">wpnPrint</a>(<span class="stringliteral">&quot;[wpnfsm] &quot;</span> + <a class="code hl_class" href="../../d8/d83/class_object.html">Object</a>.GetDebugName(<a class="code hl_variable" href="../../de/dc3/_guards_8c.html#ad0af4429be0c56056dbf78f31157a010">m_weapon</a>) + <span class="stringliteral">&quot; { Fireout F&quot;</span>); } super.OnEntry(e); }</div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno"><a class="line" href="../../dc/dcc/class_weapon_stable_state.html#a2b24124714481d5944daedea764ef07a">   30</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../dc/dcc/class_weapon_stable_state.html#a2b24124714481d5944daedea764ef07a">OnExit</a> (<a class="code hl_class" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a> e) { super.OnExit(e); <span class="keywordflow">if</span> (<a class="code hl_class" href="../../d9/df7/class_log_manager.html">LogManager</a>.<a class="code hl_function" href="../../d9/df7/class_log_manager.html#a1936dba0ee4da1a581859d6603178326">IsWeaponLogEnable</a>()) { <a class="code hl_function" href="../../dc/d1d/4___world_2_entities_2_firearms_2_debug_8c.html#a40adfc1e22a9b751658055847f9c4b83">wpnPrint</a>(<span class="stringliteral">&quot;[wpnfsm] &quot;</span> + <a class="code hl_class" href="../../d8/d83/class_object.html">Object</a>.GetDebugName(<a class="code hl_variable" href="../../de/dc3/_guards_8c.html#ad0af4429be0c56056dbf78f31157a010">m_weapon</a>) + <span class="stringliteral">&quot; } Fireout F&quot;</span>); } }</div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno"><a class="line" href="../../dc/dcc/class_weapon_stable_state.html#a71d886cf9e101812137133a25a5efc5d">   31</a></span>    <span class="keyword">override</span> <span class="keywordtype">int</span> <a class="code hl_function" href="../../dc/dcc/class_weapon_stable_state.html#a71d886cf9e101812137133a25a5efc5d">GetCurrentStateID</a> () { <span class="keywordflow">return</span> <a class="code hl_enumeration" href="../../d6/dd0/_flaregun_8c.html#a2f979fdd8cbc87aab4152a13b56d2163">FLAREStableStateID</a>.Fireout; }</div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno"><a class="line" href="../../dc/dcc/class_weapon_stable_state.html#a4b66543cd3ec146ccb5bdf7da9b82be2">   32</a></span>    <span class="keyword">override</span> <span class="keywordtype">bool</span> <a class="code hl_function" href="../../dc/dcc/class_weapon_stable_state.html#a4b66543cd3ec146ccb5bdf7da9b82be2">HasBullet</a> () { <span class="keywordflow">return</span> <span class="keyword">true</span>; }</div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno"><a class="line" href="../../dc/dcc/class_weapon_stable_state.html#ae6fd560194ec4459eb3731047b22d510">   33</a></span>    <span class="keyword">override</span> <span class="keywordtype">bool</span> <a class="code hl_function" href="../../dc/dcc/class_weapon_stable_state.html#ae6fd560194ec4459eb3731047b22d510">HasMagazine</a> () { <span class="keywordflow">return</span> <span class="keyword">false</span>; }</div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno"><a class="line" href="../../dc/dcc/class_weapon_stable_state.html#a17fafa12bb56d472c515b8dc2a1669a8">   34</a></span>    <span class="keyword">override</span> <span class="keywordtype">bool</span> <a class="code hl_function" href="../../dc/dcc/class_weapon_stable_state.html#a17fafa12bb56d472c515b8dc2a1669a8">IsJammed</a> () { <span class="keywordflow">return</span> <span class="keyword">false</span>; }</div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno"><a class="line" href="../../dc/dcc/class_weapon_stable_state.html#a0977d8061eff3cff870b2e8bfc1c4fcf">   35</a></span>    <span class="keyword">override</span> <span class="keywordtype">bool</span> <a class="code hl_function" href="../../dc/dcc/class_weapon_stable_state.html#a0977d8061eff3cff870b2e8bfc1c4fcf">IsBoltOpen</a> () { <span class="keywordflow">return</span> <span class="keyword">false</span>; }</div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno"><a class="line" href="../../dc/dcc/class_weapon_stable_state.html#ac25b31cf36d1dadc8120054f1eb43e5e">   36</a></span>    <span class="keyword">override</span> <span class="keywordtype">bool</span> <a class="code hl_function" href="../../dc/dcc/class_weapon_stable_state.html#ac25b31cf36d1dadc8120054f1eb43e5e">IsRepairEnabled</a> () { <span class="keywordflow">return</span> <span class="keyword">true</span>; }</div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno"><a class="line" href="../../dc/dcc/class_weapon_stable_state.html#a3ec895a8ef12f28fbb3e1acb39c82369">   37</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../dc/dcc/class_weapon_stable_state.html#a3ec895a8ef12f28fbb3e1acb39c82369">InitMuzzleArray</a> () { <a class="code hl_variable" href="../../d8/d8f/_weapon_stable_state_8c.html#a99c0c3c305a37383f835abc512f2be3f">m_muzzleHasBullet</a> = {<a class="code hl_enumeration" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38">MuzzleState</a>.F}; }</div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno"><a class="line" href="../../d6/dd0/_flaregun_8c.html#a4d87a97f99664b14afec8fc1e91c6fcd">   38</a></span>};</div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span><span class="keyword">class </span>FLARELoaded <span class="keyword">extends</span> <a class="code hl_class" href="../../dc/dcc/class_weapon_stable_state.html">WeaponStableState</a></div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span>{</div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno"><a class="line" href="../../dc/dcc/class_weapon_stable_state.html#a4317e82e93379b1e0cdcb1112796367d">   41</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../dc/dcc/class_weapon_stable_state.html#a4317e82e93379b1e0cdcb1112796367d">OnEntry</a> (<a class="code hl_class" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a> e) { <span class="keywordflow">if</span> (<a class="code hl_class" href="../../d9/df7/class_log_manager.html">LogManager</a>.<a class="code hl_function" href="../../d9/df7/class_log_manager.html#a1936dba0ee4da1a581859d6603178326">IsWeaponLogEnable</a>()) { <a class="code hl_function" href="../../dc/d1d/4___world_2_entities_2_firearms_2_debug_8c.html#a40adfc1e22a9b751658055847f9c4b83">wpnPrint</a>(<span class="stringliteral">&quot;[wpnfsm] &quot;</span> + <a class="code hl_class" href="../../d8/d83/class_object.html">Object</a>.GetDebugName(<a class="code hl_variable" href="../../de/dc3/_guards_8c.html#ad0af4429be0c56056dbf78f31157a010">m_weapon</a>) + <span class="stringliteral">&quot; { Loaded C&quot;</span>); } super.OnEntry(e); }</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno"><a class="line" href="../../dc/dcc/class_weapon_stable_state.html#a2b24124714481d5944daedea764ef07a">   42</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../dc/dcc/class_weapon_stable_state.html#a2b24124714481d5944daedea764ef07a">OnExit</a> (<a class="code hl_class" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a> e) { super.OnExit(e); <span class="keywordflow">if</span> (<a class="code hl_class" href="../../d9/df7/class_log_manager.html">LogManager</a>.<a class="code hl_function" href="../../d9/df7/class_log_manager.html#a1936dba0ee4da1a581859d6603178326">IsWeaponLogEnable</a>()) { <a class="code hl_function" href="../../dc/d1d/4___world_2_entities_2_firearms_2_debug_8c.html#a40adfc1e22a9b751658055847f9c4b83">wpnPrint</a>(<span class="stringliteral">&quot;[wpnfsm] &quot;</span> + <a class="code hl_class" href="../../d8/d83/class_object.html">Object</a>.GetDebugName(<a class="code hl_variable" href="../../de/dc3/_guards_8c.html#ad0af4429be0c56056dbf78f31157a010">m_weapon</a>) + <span class="stringliteral">&quot; } Loaded C&quot;</span>); } }</div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno"><a class="line" href="../../dc/dcc/class_weapon_stable_state.html#a71d886cf9e101812137133a25a5efc5d">   43</a></span>    <span class="keyword">override</span> <span class="keywordtype">int</span> <a class="code hl_function" href="../../dc/dcc/class_weapon_stable_state.html#a71d886cf9e101812137133a25a5efc5d">GetCurrentStateID</a> () { <span class="keywordflow">return</span> <a class="code hl_enumeration" href="../../d6/dd0/_flaregun_8c.html#a2f979fdd8cbc87aab4152a13b56d2163">FLAREStableStateID</a>.Loaded; }</div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno"><a class="line" href="../../dc/dcc/class_weapon_stable_state.html#a4b66543cd3ec146ccb5bdf7da9b82be2">   44</a></span>    <span class="keyword">override</span> <span class="keywordtype">bool</span> <a class="code hl_function" href="../../dc/dcc/class_weapon_stable_state.html#a4b66543cd3ec146ccb5bdf7da9b82be2">HasBullet</a> () { <span class="keywordflow">return</span> <span class="keyword">true</span>; }</div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno"><a class="line" href="../../dc/dcc/class_weapon_stable_state.html#ae6fd560194ec4459eb3731047b22d510">   45</a></span>    <span class="keyword">override</span> <span class="keywordtype">bool</span> <a class="code hl_function" href="../../dc/dcc/class_weapon_stable_state.html#ae6fd560194ec4459eb3731047b22d510">HasMagazine</a> () { <span class="keywordflow">return</span> <span class="keyword">false</span>; }</div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno"><a class="line" href="../../dc/dcc/class_weapon_stable_state.html#a17fafa12bb56d472c515b8dc2a1669a8">   46</a></span>    <span class="keyword">override</span> <span class="keywordtype">bool</span> <a class="code hl_function" href="../../dc/dcc/class_weapon_stable_state.html#a17fafa12bb56d472c515b8dc2a1669a8">IsJammed</a> () { <span class="keywordflow">return</span> <span class="keyword">false</span>; }</div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno"><a class="line" href="../../dc/dcc/class_weapon_stable_state.html#a0977d8061eff3cff870b2e8bfc1c4fcf">   47</a></span>    <span class="keyword">override</span> <span class="keywordtype">bool</span> <a class="code hl_function" href="../../dc/dcc/class_weapon_stable_state.html#a0977d8061eff3cff870b2e8bfc1c4fcf">IsBoltOpen</a> () { <span class="keywordflow">return</span> <span class="keyword">false</span>; }</div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno"><a class="line" href="../../dc/dcc/class_weapon_stable_state.html#ac25b31cf36d1dadc8120054f1eb43e5e">   48</a></span>    <span class="keyword">override</span> <span class="keywordtype">bool</span> <a class="code hl_function" href="../../dc/dcc/class_weapon_stable_state.html#ac25b31cf36d1dadc8120054f1eb43e5e">IsRepairEnabled</a> () { <span class="keywordflow">return</span> <span class="keyword">true</span>; }</div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno"><a class="line" href="../../dc/dcc/class_weapon_stable_state.html#a3ec895a8ef12f28fbb3e1acb39c82369">   49</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../dc/dcc/class_weapon_stable_state.html#a3ec895a8ef12f28fbb3e1acb39c82369">InitMuzzleArray</a> () { <a class="code hl_variable" href="../../d8/d8f/_weapon_stable_state_8c.html#a99c0c3c305a37383f835abc512f2be3f">m_muzzleHasBullet</a> = {<a class="code hl_enumeration" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38">MuzzleState</a>.L}; }</div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span>};</div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span> </div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno"><a class="line" href="../../dd/d7d/class_flaregun.html">   52</a></span><span class="keyword">class </span><a class="code hl_class" href="../../dd/d7d/class_flaregun.html">Flaregun</a>: <a class="code hl_class" href="../../d3/d9c/class_weapon___base.html">Weapon_Base</a></div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span>{</div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno"><a class="line" href="../../dd/d7d/class_flaregun.html#ae1cecc4058c238726a00eb0cf540b536">   54</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../dd/d7d/class_flaregun.html#ae1cecc4058c238726a00eb0cf540b536">InitStateMachine</a>()</div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span>    {</div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span>        <span class="comment">// setup abilities</span></div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span>        m_abilities.Insert(<span class="keyword">new</span> <a class="code hl_class" href="../../d9/d74/class_ability_record.html">AbilityRecord</a>(<a class="code hl_enumeration" href="../../d4/d9e/human_8c.html#a70aa34d22d03160ea5e3d5248cd37093">WeaponActions</a>.MECHANISM, WeaponActionMechanismTypes.MECHANISM_CLOSED));</div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span>        m_abilities.Insert(<span class="keyword">new</span> <a class="code hl_class" href="../../d9/d74/class_ability_record.html">AbilityRecord</a>(<a class="code hl_enumeration" href="../../d4/d9e/human_8c.html#a70aa34d22d03160ea5e3d5248cd37093">WeaponActions</a>.MECHANISM, WeaponActionMechanismTypes.MECHANISM_OPENED));</div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span>        m_abilities.Insert(<span class="keyword">new</span> <a class="code hl_class" href="../../d9/d74/class_ability_record.html">AbilityRecord</a>(<a class="code hl_enumeration" href="../../d4/d9e/human_8c.html#a70aa34d22d03160ea5e3d5248cd37093">WeaponActions</a>.CHAMBERING, <a class="code hl_enumeration" href="../../d4/d9e/human_8c.html#a6a33c0b8bed2b0654c3a8b8edd8acc50">WeaponActionChamberingTypes</a>.CHAMBERING_ONEBULLET_CLOSED));</div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span>        m_abilities.Insert(<span class="keyword">new</span> <a class="code hl_class" href="../../d9/d74/class_ability_record.html">AbilityRecord</a>(<a class="code hl_enumeration" href="../../d4/d9e/human_8c.html#a70aa34d22d03160ea5e3d5248cd37093">WeaponActions</a>.FIRE, <a class="code hl_enumeration" href="../../d4/d9e/human_8c.html#afb47cd06a4c376f519f3881f5ebeec9a">WeaponActionFireTypes</a>.FIRE_NORMAL));</div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span>        m_abilities.Insert(<span class="keyword">new</span> <a class="code hl_class" href="../../d9/d74/class_ability_record.html">AbilityRecord</a>(<a class="code hl_enumeration" href="../../d4/d9e/human_8c.html#a70aa34d22d03160ea5e3d5248cd37093">WeaponActions</a>.FIRE, <a class="code hl_enumeration" href="../../d4/d9e/human_8c.html#afb47cd06a4c376f519f3881f5ebeec9a">WeaponActionFireTypes</a>.FIRE_UNCOCKED));</div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span> </div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span>        <span class="comment">// setup state machine</span></div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>        <span class="comment">// basic weapon states</span></div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span>        <a class="code hl_class" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a> <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38ab199e021998d49b1f09338d8b9b18ecb">E</a> = <span class="keyword">new</span> FLAREEmpty(<span class="keyword">this</span>, NULL, <a class="code hl_enumeration" href="../../d6/dd0/_flaregun_8c.html#a94a48508f9de4c308a774a69b91c9fd9">FLAREAnimState</a>.UNCOCKED);</div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>        <a class="code hl_class" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a> <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38af382a63cc3d6491bf26b59e66f46826d">F</a> = <span class="keyword">new</span> FLAREFireout(<span class="keyword">this</span>, NULL, <a class="code hl_enumeration" href="../../d6/dd0/_flaregun_8c.html#a94a48508f9de4c308a774a69b91c9fd9">FLAREAnimState</a>.UNCOCKED);</div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>        <a class="code hl_class" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a> <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38aef31cc6fe9479955961311ee18ac205f">L</a> = <span class="keyword">new</span> FLARELoaded(<span class="keyword">this</span>, NULL, <a class="code hl_enumeration" href="../../d6/dd0/_flaregun_8c.html#a94a48508f9de4c308a774a69b91c9fd9">FLAREAnimState</a>.COCKED);</div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span>        <span class="comment">// unstable (intermediate) states</span></div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>        <a class="code hl_class" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a> Mech_F = <span class="keyword">new</span> <a class="code hl_class" href="../../d0/deb/namespace_3global_scope_4.html#dc/df0/class_weapon_charging">WeaponCharging</a>(<span class="keyword">this</span>, NULL, <a class="code hl_enumeration" href="../../d4/d9e/human_8c.html#a70aa34d22d03160ea5e3d5248cd37093">WeaponActions</a>.MECHANISM, WeaponActionMechanismTypes.MECHANISM_CLOSED);</div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span>        <a class="code hl_class" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a> Mech_L = <span class="keyword">new</span> WeaponEjectBullet(<span class="keyword">this</span>, NULL, <a class="code hl_enumeration" href="../../d4/d9e/human_8c.html#a70aa34d22d03160ea5e3d5248cd37093">WeaponActions</a>.MECHANISM, WeaponActionMechanismTypes.MECHANISM_OPENED);</div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>        </div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>        <a class="code hl_class" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a> Chamber_E = <span class="keyword">new</span> WeaponChambering(<span class="keyword">this</span>, NULL, <a class="code hl_enumeration" href="../../d4/d9e/human_8c.html#a70aa34d22d03160ea5e3d5248cd37093">WeaponActions</a>.CHAMBERING, <a class="code hl_enumeration" href="../../d4/d9e/human_8c.html#a6a33c0b8bed2b0654c3a8b8edd8acc50">WeaponActionChamberingTypes</a>.CHAMBERING_ONEBULLET_CLOSED);</div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span>        <a class="code hl_class" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a> Chamber_F = <span class="keyword">new</span> WeaponChambering(<span class="keyword">this</span>, NULL, <a class="code hl_enumeration" href="../../d4/d9e/human_8c.html#a70aa34d22d03160ea5e3d5248cd37093">WeaponActions</a>.CHAMBERING, <a class="code hl_enumeration" href="../../d4/d9e/human_8c.html#a6a33c0b8bed2b0654c3a8b8edd8acc50">WeaponActionChamberingTypes</a>.CHAMBERING_ONEBULLET_CLOSED);</div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span>        <span class="comment">//WeaponStateBase Chamber_L = new RifleReChambering(this, NULL, WeaponActions.CHAMBERING, WeaponActionChamberingTypes.CHAMBERING_ONEBULLET_CLOSED);</span></div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>        </div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span>        <a class="code hl_class" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a> Trigger_E = <span class="keyword">new</span> WeaponDryFire(<span class="keyword">this</span>, NULL, <a class="code hl_enumeration" href="../../d4/d9e/human_8c.html#a70aa34d22d03160ea5e3d5248cd37093">WeaponActions</a>.FIRE, <a class="code hl_enumeration" href="../../d4/d9e/human_8c.html#afb47cd06a4c376f519f3881f5ebeec9a">WeaponActionFireTypes</a>.FIRE_UNCOCKED);</div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span>        <a class="code hl_class" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a> Trigger_L = <span class="keyword">new</span> <a class="code hl_class" href="../../d5/db3/class_weapon_fire.html">WeaponFire</a>(<span class="keyword">this</span>, NULL, <a class="code hl_enumeration" href="../../d4/d9e/human_8c.html#a70aa34d22d03160ea5e3d5248cd37093">WeaponActions</a>.FIRE, <a class="code hl_enumeration" href="../../d4/d9e/human_8c.html#afb47cd06a4c376f519f3881f5ebeec9a">WeaponActionFireTypes</a>.FIRE_NORMAL);</div>
<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span>        <a class="code hl_class" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a> Trigger_F = <span class="keyword">new</span> WeaponDryFire(<span class="keyword">this</span>, NULL, <a class="code hl_enumeration" href="../../d4/d9e/human_8c.html#a70aa34d22d03160ea5e3d5248cd37093">WeaponActions</a>.FIRE, <a class="code hl_enumeration" href="../../d4/d9e/human_8c.html#afb47cd06a4c376f519f3881f5ebeec9a">WeaponActionFireTypes</a>.FIRE_UNCOCKED);</div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span> </div>
<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span> </div>
<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>        <span class="comment">// events</span></div>
<div class="line"><a id="l00082" name="l00082"></a><span class="lineno">   82</span>        <a class="code hl_class" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a> __M__ = <span class="keyword">new</span> WeaponEventMechanism;</div>
<div class="line"><a id="l00083" name="l00083"></a><span class="lineno">   83</span>        <a class="code hl_class" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a> __T__ = <span class="keyword">new</span> WeaponEventTrigger;</div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span>        <a class="code hl_class" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a> __TJ_ = <span class="keyword">new</span> WeaponEventTriggerToJam;</div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span>        <a class="code hl_class" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a> __L__ = <span class="keyword">new</span> WeaponEventLoad1Bullet;</div>
<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span>        <a class="code hl_class" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a> __U__ = <span class="keyword">new</span> WeaponEventUnjam;</div>
<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span>        <a class="code hl_class" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a> _fin_ = <span class="keyword">new</span> WeaponEventHumanCommandActionFinished;</div>
<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span>        <a class="code hl_class" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a> _abt_ = <span class="keyword">new</span> WeaponEventHumanCommandActionAborted;</div>
<div class="line"><a id="l00089" name="l00089"></a><span class="lineno">   89</span>        <a class="code hl_class" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a> _dto_ = <span class="keyword">new</span> WeaponEventDryFireTimeout;</div>
<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span> </div>
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span>        m_fsm = <span class="keyword">new</span> <a class="code hl_class" href="../../d0/deb/namespace_3global_scope_4.html#dc/d73/class_weapon_f_s_m">WeaponFSM</a>();</div>
<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span>        <span class="comment">// charging</span></div>
<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span>        m_fsm.AddTransition(<span class="keyword">new</span> <a class="code hl_typedef" href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a>( <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38ab199e021998d49b1f09338d8b9b18ecb">E</a>,            __M__,  Mech_F));</div>
<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span>        m_fsm.AddTransition(<span class="keyword">new</span> <a class="code hl_typedef" href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a>( <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38af382a63cc3d6491bf26b59e66f46826d">F</a>,            __M__,  Mech_F));</div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span>        m_fsm.AddTransition(<span class="keyword">new</span> <a class="code hl_typedef" href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a>(  Mech_F,      _fin_,  <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38ab199e021998d49b1f09338d8b9b18ecb">E</a>));</div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>        m_fsm.AddTransition(<span class="keyword">new</span> <a class="code hl_typedef" href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a>(  Mech_F,      _abt_,  <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38af382a63cc3d6491bf26b59e66f46826d">F</a>, NULL, <span class="keyword">new</span> WeaponGuardCurrentChamberFiredOut(<span class="keyword">this</span>)));</div>
<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span>        m_fsm.AddTransition(<span class="keyword">new</span> <a class="code hl_typedef" href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a>(  Mech_F,      _abt_,  <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38ab199e021998d49b1f09338d8b9b18ecb">E</a>));</div>
<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span>        </div>
<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span>        <span class="comment">// eject good cartridge</span></div>
<div class="line"><a id="l00100" name="l00100"></a><span class="lineno">  100</span>        m_fsm.AddTransition(<span class="keyword">new</span> <a class="code hl_typedef" href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a>( <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38aef31cc6fe9479955961311ee18ac205f">L</a>,            __M__,  Mech_L));</div>
<div class="line"><a id="l00101" name="l00101"></a><span class="lineno">  101</span>        m_fsm.AddTransition(<span class="keyword">new</span> <a class="code hl_typedef" href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a>(  Mech_L,      _fin_,  <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38ab199e021998d49b1f09338d8b9b18ecb">E</a>));</div>
<div class="line"><a id="l00102" name="l00102"></a><span class="lineno">  102</span>        m_fsm.AddTransition(<span class="keyword">new</span> <a class="code hl_typedef" href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a>(  Mech_L,      _abt_,  <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38ab199e021998d49b1f09338d8b9b18ecb">E</a>, NULL, <span class="keyword">new</span> WeaponGuardCurrentChamberEmpty(<span class="keyword">this</span>)));</div>
<div class="line"><a id="l00103" name="l00103"></a><span class="lineno">  103</span>        m_fsm.AddTransition(<span class="keyword">new</span> <a class="code hl_typedef" href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a>(  Mech_L,      _abt_,  <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38aef31cc6fe9479955961311ee18ac205f">L</a>));</div>
<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span> </div>
<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span>        m_fsm.AddTransition(<span class="keyword">new</span> <a class="code hl_typedef" href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a>( <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38ab199e021998d49b1f09338d8b9b18ecb">E</a>,            __L__,  Chamber_F));</div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span>        m_fsm.AddTransition(<span class="keyword">new</span> <a class="code hl_typedef" href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a>( <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38af382a63cc3d6491bf26b59e66f46826d">F</a>,            __L__,  Chamber_F));</div>
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span>        m_fsm.AddTransition(<span class="keyword">new</span> <a class="code hl_typedef" href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a>(  Chamber_F,   _fin_,  <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38aef31cc6fe9479955961311ee18ac205f">L</a>));</div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>        m_fsm.AddTransition(<span class="keyword">new</span> <a class="code hl_typedef" href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a>(  Chamber_F,   _abt_,  <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38af382a63cc3d6491bf26b59e66f46826d">F</a>, NULL, <span class="keyword">new</span> WeaponGuardCurrentChamberFiredOut(<span class="keyword">this</span>)));</div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span>        m_fsm.AddTransition(<span class="keyword">new</span> <a class="code hl_typedef" href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a>(  Chamber_F,   _abt_,  <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38ab199e021998d49b1f09338d8b9b18ecb">E</a>, NULL, <span class="keyword">new</span> WeaponGuardCurrentChamberEmpty(<span class="keyword">this</span>)));</div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>        m_fsm.AddTransition(<span class="keyword">new</span> <a class="code hl_typedef" href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a>(  Chamber_F,   _abt_,  <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38aef31cc6fe9479955961311ee18ac205f">L</a>));</div>
<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span> </div>
<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span>        <span class="comment">// fire</span></div>
<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span>        m_fsm.AddTransition(<span class="keyword">new</span> <a class="code hl_typedef" href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a>( <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38ab199e021998d49b1f09338d8b9b18ecb">E</a>,            __T__,  Trigger_E)); <span class="comment">// fire cocked</span></div>
<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span>        m_fsm.AddTransition(<span class="keyword">new</span> <a class="code hl_typedef" href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a>(  Trigger_E,   _fin_,  <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38ab199e021998d49b1f09338d8b9b18ecb">E</a>));</div>
<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span>        m_fsm.AddTransition(<span class="keyword">new</span> <a class="code hl_typedef" href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a>(  Trigger_E,   _dto_,  <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38ab199e021998d49b1f09338d8b9b18ecb">E</a>));</div>
<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span>        m_fsm.AddTransition(<span class="keyword">new</span> <a class="code hl_typedef" href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a>(  Trigger_E,   _abt_,  <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38ab199e021998d49b1f09338d8b9b18ecb">E</a>));</div>
<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span>        </div>
<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span>        m_fsm.AddTransition(<span class="keyword">new</span> <a class="code hl_typedef" href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a>( <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38af382a63cc3d6491bf26b59e66f46826d">F</a>,            __T__,  Trigger_F)); <span class="comment">// fire uncocked</span></div>
<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span>        m_fsm.AddTransition(<span class="keyword">new</span> <a class="code hl_typedef" href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a>(  Trigger_F,   _fin_,  <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38af382a63cc3d6491bf26b59e66f46826d">F</a>));</div>
<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span>        m_fsm.AddTransition(<span class="keyword">new</span> <a class="code hl_typedef" href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a>(  Trigger_F,   _dto_,  <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38af382a63cc3d6491bf26b59e66f46826d">F</a>));</div>
<div class="line"><a id="l00121" name="l00121"></a><span class="lineno">  121</span>        m_fsm.AddTransition(<span class="keyword">new</span> <a class="code hl_typedef" href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a>(  Trigger_F,   _abt_,  <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38af382a63cc3d6491bf26b59e66f46826d">F</a>));</div>
<div class="line"><a id="l00122" name="l00122"></a><span class="lineno">  122</span>        </div>
<div class="line"><a id="l00123" name="l00123"></a><span class="lineno">  123</span>        m_fsm.AddTransition(<span class="keyword">new</span> <a class="code hl_typedef" href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a>( <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38aef31cc6fe9479955961311ee18ac205f">L</a>,            __T__,  Trigger_L)); <span class="comment">// a) fire if not jammed</span></div>
<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span>        m_fsm.AddTransition(<span class="keyword">new</span> <a class="code hl_typedef" href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a>(  Trigger_L,   _fin_,  <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38af382a63cc3d6491bf26b59e66f46826d">F</a>));</div>
<div class="line"><a id="l00125" name="l00125"></a><span class="lineno">  125</span>        m_fsm.AddTransition(<span class="keyword">new</span> <a class="code hl_typedef" href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a>(  Trigger_L,   _abt_,  <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38af382a63cc3d6491bf26b59e66f46826d">F</a>));</div>
<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span>        </div>
<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span> </div>
<div class="line"><a id="l00128" name="l00128"></a><span class="lineno">  128</span>        <span class="comment">// initial state setup</span></div>
<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span>        <span class="keywordtype">bool</span> empty = <span class="keyword">true</span>;</div>
<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span>        <span class="keywordtype">bool</span> discharged = <span class="keyword">false</span>; <span class="comment">// @TODO:</span></div>
<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span>        <a class="code hl_class" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a> init_state = <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38ab199e021998d49b1f09338d8b9b18ecb">E</a>;</div>
<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span>        <span class="keywordflow">if</span> (empty)</div>
<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span>        {</div>
<div class="line"><a id="l00134" name="l00134"></a><span class="lineno">  134</span>            <span class="keywordflow">if</span> (!discharged)</div>
<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span>                init_state = <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38ab199e021998d49b1f09338d8b9b18ecb">E</a>;</div>
<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span>        }</div>
<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span>        {</div>
<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span>            init_state = <a class="code hl_enumvalue" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38aef31cc6fe9479955961311ee18ac205f">L</a>; <span class="comment">// can init state == load/jammed?</span></div>
<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span>        }</div>
<div class="line"><a id="l00141" name="l00141"></a><span class="lineno">  141</span>        m_fsm.SetInitialState(init_state);</div>
<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span> </div>
<div class="line"><a id="l00143" name="l00143"></a><span class="lineno">  143</span>        SelectionBulletHide();</div>
<div class="line"><a id="l00144" name="l00144"></a><span class="lineno">  144</span> </div>
<div class="line"><a id="l00145" name="l00145"></a><span class="lineno">  145</span>        m_fsm.Start();</div>
<div class="line"><a id="l00146" name="l00146"></a><span class="lineno">  146</span>    }</div>
<div class="line"><a id="l00147" name="l00147"></a><span class="lineno">  147</span>};</div>
<div class="ttc" id="a4___world_2_entities_2_firearms_2_debug_8c_html_a40adfc1e22a9b751658055847f9c4b83"><div class="ttname"><a href="../../dc/d1d/4___world_2_entities_2_firearms_2_debug_8c.html#a40adfc1e22a9b751658055847f9c4b83">wpnPrint</a></div><div class="ttdeci">void wpnPrint(string s)</div><div class="ttdef"><b>Definition:</b> <a href="../../dc/d1d/4___world_2_entities_2_firearms_2_debug_8c_source.html#l00001">Debug.c:1</a></div></div>
<div class="ttc" id="a_flaregun_8c_html_a211f8e095b3b0e62b5e1fbc5ac330c15"><div class="ttname"><a href="../../d6/dd0/_flaregun_8c.html#a211f8e095b3b0e62b5e1fbc5ac330c15">Loaded</a></div><div class="ttdeci">Loaded</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/dd0/_flaregun_8c_source.html#l00021">Flaregun.c:21</a></div></div>
<div class="ttc" id="a_flaregun_8c_html_a2f979fdd8cbc87aab4152a13b56d2163"><div class="ttname"><a href="../../d6/dd0/_flaregun_8c.html#a2f979fdd8cbc87aab4152a13b56d2163">FLAREStableStateID</a></div><div class="ttdeci">FLAREStableStateID</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/dd0/_flaregun_8c_source.html#l00007">Flaregun.c:8</a></div></div>
<div class="ttc" id="a_flaregun_8c_html_a6ce26a62afab55d7606ad4e92428b30c"><div class="ttname"><a href="../../d6/dd0/_flaregun_8c.html#a6ce26a62afab55d7606ad4e92428b30c">UNKNOWN</a></div><div class="ttdeci">UNKNOWN</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/dd0/_flaregun_8c_source.html#l00018">Flaregun.c:18</a></div></div>
<div class="ttc" id="a_flaregun_8c_html_a891fbec6fb0d74aea9e064d13b59c9e0"><div class="ttname"><a href="../../d6/dd0/_flaregun_8c.html#a891fbec6fb0d74aea9e064d13b59c9e0">Empty</a></div><div class="ttdeci">Empty</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/dd0/_flaregun_8c_source.html#l00019">Flaregun.c:19</a></div></div>
<div class="ttc" id="a_flaregun_8c_html_a8aa2378201749f3aa5ffa8dd152c8e95"><div class="ttname"><a href="../../d6/dd0/_flaregun_8c.html#a8aa2378201749f3aa5ffa8dd152c8e95">Fireout</a></div><div class="ttdeci">Fireout</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/dd0/_flaregun_8c_source.html#l00020">Flaregun.c:20</a></div></div>
<div class="ttc" id="a_flaregun_8c_html_a94a48508f9de4c308a774a69b91c9fd9"><div class="ttname"><a href="../../d6/dd0/_flaregun_8c.html#a94a48508f9de4c308a774a69b91c9fd9">FLAREAnimState</a></div><div class="ttdeci">FLAREAnimState</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/dd0/_flaregun_8c_source.html#l00001">Flaregun.c:2</a></div></div>
<div class="ttc" id="a_flaregun_8c_html_a94a48508f9de4c308a774a69b91c9fd9a5524ea9109ec7996fc51cbb86426b8f1"><div class="ttname"><a href="../../d6/dd0/_flaregun_8c.html#a94a48508f9de4c308a774a69b91c9fd9a5524ea9109ec7996fc51cbb86426b8f1">UNCOCKED</a></div><div class="ttdeci">@ UNCOCKED</div><div class="ttdoc">default weapon state, closed and discharged</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/dd0/_flaregun_8c_source.html#l00004">Flaregun.c:4</a></div></div>
<div class="ttc" id="a_flaregun_8c_html_a94a48508f9de4c308a774a69b91c9fd9ad2f7012ff73e5095016573ed46f929a4"><div class="ttname"><a href="../../d6/dd0/_flaregun_8c.html#a94a48508f9de4c308a774a69b91c9fd9ad2f7012ff73e5095016573ed46f929a4">COCKED</a></div><div class="ttdeci">@ COCKED</div><div class="ttdoc">default weapon state, closed and discharged</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/dd0/_flaregun_8c_source.html#l00003">Flaregun.c:3</a></div></div>
<div class="ttc" id="a_guards_8c_html_ad0af4429be0c56056dbf78f31157a010"><div class="ttname"><a href="../../de/dc3/_guards_8c.html#ad0af4429be0c56056dbf78f31157a010">m_weapon</a></div><div class="ttdeci">class WeaponGuardIsDestroyed extends WeaponGuardBase m_weapon</div></div>
<div class="ttc" id="a_single_shot_pistol___base_8c_html_a3ed70c6f00023473563b38dd40750479"><div class="ttname"><a href="../../d2/db3/_single_shot_pistol___base_8c.html#a3ed70c6f00023473563b38dd40750479">OnEntry</a></div><div class="ttdeci">class SSPFireout extends WeaponStableState OnEntry</div></div>
<div class="ttc" id="a_weapon___base_8c_html_aad9c748f817f5536f4f2bfd213b4afc1"><div class="ttname"><a href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a></div><div class="ttdeci">enum FSMTransition WeaponTransition</div></div>
<div class="ttc" id="a_weapon_stable_state_8c_html_a81850a19579d69fbd62d39a8f08a5f38"><div class="ttname"><a href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38">MuzzleState</a></div><div class="ttdeci">MuzzleState</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d8f/_weapon_stable_state_8c_source.html#l00014">WeaponStableState.c:15</a></div></div>
<div class="ttc" id="a_weapon_stable_state_8c_html_a81850a19579d69fbd62d39a8f08a5f38ab199e021998d49b1f09338d8b9b18ecb"><div class="ttname"><a href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38ab199e021998d49b1f09338d8b9b18ecb">E</a></div><div class="ttdeci">@ E</div><div class="ttdoc">EMPTY.</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d8f/_weapon_stable_state_8c_source.html#l00019">WeaponStableState.c:19</a></div></div>
<div class="ttc" id="a_weapon_stable_state_8c_html_a81850a19579d69fbd62d39a8f08a5f38aef31cc6fe9479955961311ee18ac205f"><div class="ttname"><a href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38aef31cc6fe9479955961311ee18ac205f">L</a></div><div class="ttdeci">@ L</div><div class="ttdoc">LOADED.</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d8f/_weapon_stable_state_8c_source.html#l00024">WeaponStableState.c:23</a></div></div>
<div class="ttc" id="a_weapon_stable_state_8c_html_a81850a19579d69fbd62d39a8f08a5f38af382a63cc3d6491bf26b59e66f46826d"><div class="ttname"><a href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38af382a63cc3d6491bf26b59e66f46826d">F</a></div><div class="ttdeci">@ F</div><div class="ttdoc">FIRED.</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d8f/_weapon_stable_state_8c_source.html#l00021">WeaponStableState.c:21</a></div></div>
<div class="ttc" id="a_weapon_stable_state_8c_html_a99c0c3c305a37383f835abc512f2be3f"><div class="ttname"><a href="../../d8/d8f/_weapon_stable_state_8c.html#a99c0c3c305a37383f835abc512f2be3f">m_muzzleHasBullet</a></div><div class="ttdeci">ref array&lt; MuzzleState &gt; m_muzzleHasBullet</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d8f/_weapon_stable_state_8c_source.html#l00030">WeaponStableState.c:30</a></div></div>
<div class="ttc" id="aclass_ability_record_html"><div class="ttname"><a href="../../d9/d74/class_ability_record.html">AbilityRecord</a></div><div class="ttdoc">pair ( action, actionType )</div><div class="ttdef"><b>Definition:</b> <a href="../../de/df2/_weapon___base_8c_source.html#l00004">Weapon_Base.c:5</a></div></div>
<div class="ttc" id="aclass_flaregun_html"><div class="ttname"><a href="../../dd/d7d/class_flaregun.html">Flaregun</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d6/dd0/_flaregun_8c_source.html#l00052">Flaregun.c:53</a></div></div>
<div class="ttc" id="aclass_flaregun_html_ae1cecc4058c238726a00eb0cf540b536"><div class="ttname"><a href="../../dd/d7d/class_flaregun.html#ae1cecc4058c238726a00eb0cf540b536">Flaregun::InitStateMachine</a></div><div class="ttdeci">override void InitStateMachine()</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/dd0/_flaregun_8c_source.html#l00054">Flaregun.c:54</a></div></div>
<div class="ttc" id="aclass_log_manager_html"><div class="ttname"><a href="../../d9/df7/class_log_manager.html">LogManager</a></div><div class="ttdef"><b>Definition:</b> <a href="../../de/d4c/3___game_2tools_2_debug_8c_source.html#l00542">Debug.c:543</a></div></div>
<div class="ttc" id="aclass_log_manager_html_a1936dba0ee4da1a581859d6603178326"><div class="ttname"><a href="../../d9/df7/class_log_manager.html#a1936dba0ee4da1a581859d6603178326">LogManager::IsWeaponLogEnable</a></div><div class="ttdeci">static bool IsWeaponLogEnable()</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d4c/3___game_2tools_2_debug_8c_source.html#l00628">Debug.c:628</a></div></div>
<div class="ttc" id="aclass_object_html"><div class="ttname"><a href="../../d8/d83/class_object.html">Object</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d7/d68/_object_typed_8c_source.html#l00001">ObjectTyped.c:2</a></div></div>
<div class="ttc" id="aclass_weapon___base_html"><div class="ttname"><a href="../../d3/d9c/class_weapon___base.html">Weapon_Base</a></div><div class="ttdoc">shorthand</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d62/_bolt_action_rifle___base_8c_source.html#l00005">BoltActionRifle_Base.c:6</a></div></div>
<div class="ttc" id="aclass_weapon_event_base_html"><div class="ttname"><a href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a></div><div class="ttdoc">signalize mechanism manipulation</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/dea/_events_8c_source.html#l00034">Events.c:35</a></div></div>
<div class="ttc" id="aclass_weapon_fire_html"><div class="ttname"><a href="../../d5/db3/class_weapon_fire.html">WeaponFire</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d6b/_weapon_fire_8c_source.html#l00098">WeaponFire.c:99</a></div></div>
<div class="ttc" id="aclass_weapon_stable_state_html"><div class="ttname"><a href="../../dc/dcc/class_weapon_stable_state.html">WeaponStableState</a></div><div class="ttdoc">represents weapon's stable state (i.e. the basic states that the weapon will spend the most time in)</div><div class="ttdef"><b>Definition:</b> <a href="../../dd/daa/_s_k_s_8c_source.html#l00029">SKS.c:30</a></div></div>
<div class="ttc" id="aclass_weapon_stable_state_html_a0977d8061eff3cff870b2e8bfc1c4fcf"><div class="ttname"><a href="../../dc/dcc/class_weapon_stable_state.html#a0977d8061eff3cff870b2e8bfc1c4fcf">WeaponStableState::IsBoltOpen</a></div><div class="ttdeci">override bool IsBoltOpen()</div><div class="ttdef"><b>Definition:</b> <a href="../../dd/daa/_s_k_s_8c_source.html#l00048">SKS.c:48</a></div></div>
<div class="ttc" id="aclass_weapon_stable_state_html_a17fafa12bb56d472c515b8dc2a1669a8"><div class="ttname"><a href="../../dc/dcc/class_weapon_stable_state.html#a17fafa12bb56d472c515b8dc2a1669a8">WeaponStableState::IsJammed</a></div><div class="ttdeci">override bool IsJammed()</div><div class="ttdef"><b>Definition:</b> <a href="../../dd/daa/_s_k_s_8c_source.html#l00036">SKS.c:36</a></div></div>
<div class="ttc" id="aclass_weapon_stable_state_html_a2b24124714481d5944daedea764ef07a"><div class="ttname"><a href="../../dc/dcc/class_weapon_stable_state.html#a2b24124714481d5944daedea764ef07a">WeaponStableState::OnExit</a></div><div class="ttdeci">override void OnExit(WeaponEventBase e)</div><div class="ttdef"><b>Definition:</b> <a href="../../dd/daa/_s_k_s_8c_source.html#l00032">SKS.c:32</a></div></div>
<div class="ttc" id="aclass_weapon_stable_state_html_a3ec895a8ef12f28fbb3e1acb39c82369"><div class="ttname"><a href="../../dc/dcc/class_weapon_stable_state.html#a3ec895a8ef12f28fbb3e1acb39c82369">WeaponStableState::InitMuzzleArray</a></div><div class="ttdeci">override void InitMuzzleArray()</div><div class="ttdef"><b>Definition:</b> <a href="../../dd/daa/_s_k_s_8c_source.html#l00038">SKS.c:38</a></div></div>
<div class="ttc" id="aclass_weapon_stable_state_html_a4317e82e93379b1e0cdcb1112796367d"><div class="ttname"><a href="../../dc/dcc/class_weapon_stable_state.html#a4317e82e93379b1e0cdcb1112796367d">WeaponStableState::OnEntry</a></div><div class="ttdeci">override void OnEntry(WeaponEventBase e)</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/dd0/_flaregun_8c_source.html#l00029">Flaregun.c:29</a></div></div>
<div class="ttc" id="aclass_weapon_stable_state_html_a4b66543cd3ec146ccb5bdf7da9b82be2"><div class="ttname"><a href="../../dc/dcc/class_weapon_stable_state.html#a4b66543cd3ec146ccb5bdf7da9b82be2">WeaponStableState::HasBullet</a></div><div class="ttdeci">override bool HasBullet()</div><div class="ttdef"><b>Definition:</b> <a href="../../dd/daa/_s_k_s_8c_source.html#l00034">SKS.c:34</a></div></div>
<div class="ttc" id="aclass_weapon_stable_state_html_a71d886cf9e101812137133a25a5efc5d"><div class="ttname"><a href="../../dc/dcc/class_weapon_stable_state.html#a71d886cf9e101812137133a25a5efc5d">WeaponStableState::GetCurrentStateID</a></div><div class="ttdeci">override int GetCurrentStateID()</div><div class="ttdef"><b>Definition:</b> <a href="../../dd/daa/_s_k_s_8c_source.html#l00033">SKS.c:33</a></div></div>
<div class="ttc" id="aclass_weapon_stable_state_html_ac25b31cf36d1dadc8120054f1eb43e5e"><div class="ttname"><a href="../../dc/dcc/class_weapon_stable_state.html#ac25b31cf36d1dadc8120054f1eb43e5e">WeaponStableState::IsRepairEnabled</a></div><div class="ttdeci">override bool IsRepairEnabled()</div><div class="ttdef"><b>Definition:</b> <a href="../../dd/daa/_s_k_s_8c_source.html#l00037">SKS.c:37</a></div></div>
<div class="ttc" id="aclass_weapon_stable_state_html_ae6fd560194ec4459eb3731047b22d510"><div class="ttname"><a href="../../dc/dcc/class_weapon_stable_state.html#ae6fd560194ec4459eb3731047b22d510">WeaponStableState::HasMagazine</a></div><div class="ttdeci">override bool HasMagazine()</div><div class="ttdef"><b>Definition:</b> <a href="../../dd/daa/_s_k_s_8c_source.html#l00035">SKS.c:35</a></div></div>
<div class="ttc" id="aclass_weapon_state_base_html"><div class="ttname"><a href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a></div><div class="ttdoc">represent weapon state base</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/da2/_bullet_hide_8c_source.html#l00001">BulletHide.c:2</a></div></div>
<div class="ttc" id="ahuman_8c_html_a6a33c0b8bed2b0654c3a8b8edd8acc50"><div class="ttname"><a href="../../d4/d9e/human_8c.html#a6a33c0b8bed2b0654c3a8b8edd8acc50">WeaponActionChamberingTypes</a></div><div class="ttdeci">WeaponActionChamberingTypes</div><div class="ttdef"><b>Definition:</b> <a href="../../d4/d9e/human_8c_source.html#l00822">human.c:823</a></div></div>
<div class="ttc" id="ahuman_8c_html_a70aa34d22d03160ea5e3d5248cd37093"><div class="ttname"><a href="../../d4/d9e/human_8c.html#a70aa34d22d03160ea5e3d5248cd37093">WeaponActions</a></div><div class="ttdeci">WeaponActions</div><div class="ttdoc">actions</div><div class="ttdef"><b>Definition:</b> <a href="../../d4/d9e/human_8c_source.html#l00762">human.c:763</a></div></div>
<div class="ttc" id="ahuman_8c_html_afb47cd06a4c376f519f3881f5ebeec9a"><div class="ttname"><a href="../../d4/d9e/human_8c.html#afb47cd06a4c376f519f3881f5ebeec9a">WeaponActionFireTypes</a></div><div class="ttdeci">WeaponActionFireTypes</div><div class="ttdef"><b>Definition:</b> <a href="../../d4/d9e/human_8c_source.html#l00866">human.c:867</a></div></div>
<div class="ttc" id="anamespace_3global_scope_4_html_dc/d73/class_weapon_f_s_m"><div class="ttname"><a href="../../d0/deb/namespace_3global_scope_4.html#dc/d73/class_weapon_f_s_m">WeaponFSM</a></div><div class="ttdoc">weapon finite state machine</div></div>
<div class="ttc" id="anamespace_3global_scope_4_html_dc/df0/class_weapon_charging"><div class="ttname"><a href="../../d0/deb/namespace_3global_scope_4.html#dc/df0/class_weapon_charging">WeaponCharging</a></div><div class="ttdoc">charging of weapon without ammo to be chambered</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_dc42280174b209627d8212c9e40d7e50.html">scripts</a></li><li class="navelem"><a class="el" href="../../dir_2e5c1ab951ac691cd4fc8c5e713c6c8a.html">4_World</a></li><li class="navelem"><a class="el" href="../../dir_d92b8e0605e989b70f343f78d41d5ad9.html">Entities</a></li><li class="navelem"><a class="el" href="../../dir_76b70e186f3f0441d93c60d5e78b0414.html">Firearms</a></li><li class="navelem"><a class="el" href="../../dir_76a54f3297dfb22ebdc969318446e2b1.html">Pistol</a></li><li class="navelem"><a class="el" href="../../d6/dd0/_flaregun_8c.html">Flaregun.c</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.5 </li>
  </ul>
</div>
</body>
</html>
